module Dynamic_Drive(CLK, RESET, SW, COLUMN, SEG, DIGIT);

	input CLK, RESET;
	input [3:0] SW;
	
	output [3:0] COLUMN, SEG, DIGIT;
	
	wire [15:0] sw_number;
	
	reg [15:0] counter = 0;
	reg [15:0] buffer, out;
	
	
	SW_Matrix sw_matrix1(.CLK(CLK), .RESET(RESET), .SW(SW), .COLUMN(COLUMN), .SW_STATE(sw_number));
	Decoder decoder1(.CLK(CLK), .RESET(RESET), .Q(counter), .SEG(SEG), .DIGIT(DIGIT));
	
	always @(posedge CLK or negedge RESET)
	begin
		if (!RESET) buffer <= 0;
		else buffer <= sw_number;
	end
	
	assign inc1000 = sw_number[0] & ~buffer[0];
	assign inc100 = sw_number[1] & ~buffer[1];
	assign inc10 = sw_number[2] & ~buffer[2];
	assign inc1 = sw_number[3] & ~buffer[3];
	
	always @(posedge CLK)
	begin
		if (inc1 == 1)
			counter <= counter + 1;
		else if (inc10 == 1)
			counter <= counter + 10;
		else if (inc100 == 1)
			counter <= counter + 100;
		else if (inc1000)
			counter <= counter + 1000;
	end

endmodule
	
