module SW_Matrix(CLK, RESET, SW, COLUMN, SW_STATE);

	input CLK, RESET;
	input [3:0] SW;
	
	output [3:0] COLUMN;
	output [15:0]SW_STATE;
	
	reg [3:0] COLUMN;
	reg [1:0] count;
	reg [18:0]temp_count = 0;
	reg [15:0] SW_STATE;
	
	always @(posedge CLK or negedge RESET)
	begin
		if (!RESET) temp_count <=0;
		else temp_count <= temp_count + 1;
	end
	
	assign enable = (temp_count == 0) ? 1 : 0;
	
	always @(posedge CLK or negedge RESET)
	begin
		if (!RESET) count <= 0;
		else if (enable == 1) count <= count + 1;
	end
	
	always @(posedge CLK or negedge RESET)
	begin
		if (!RESET) COLUMN <= 0;
		else if (enable == 1)
		begin
			case(count)
				2'b00:COLUMN <= 4'b1000;
				2'b01:COLUMN <= 4'b0100;
				2'b10:COLUMN <= 4'b0010;
				2'b11:COLUMN <= 4'b0001;
			endcase
		end
	end
	
	always @(posedge CLK or negedge RESET)
	begin
		if (!RESET) SW_STATE <= 0;
		else if (enable == 1)
			if(COLUMN == 4'b1000)
			begin
				SW_STATE[0] <= SW[3];	// PSW1
				SW_STATE[4] <= SW[2];	// PSW5
				SW_STATE[8] <= SW[1]; 	// PSW9
				SW_STATE[12] <= SW[0]; 	// PSW13
			end
			else if(COLUMN == 4'b0100)
			begin
				SW_STATE[1] <= SW[3]; 	// PSW2
				SW_STATE[5] <= SW[2]; 	// PSW6
				SW_STATE[9] <= SW[1]; 	// PSW10
				SW_STATE[13] <= SW[0]; 	// PSW14
			end
			else if(COLUMN == 4'b0010)
			begin
				SW_STATE[2] <= SW[3]; 	// PSW3
				SW_STATE[6] <= SW[2]; 	// PSW7
				SW_STATE[10] <= SW[1]; 	// PSW11
				SW_STATE[14] <= SW[0]; 	// PSW15
			end
			else if(COLUMN == 4'b0001)
			begin
				SW_STATE[3] <= SW[3]; 	// PSW4
				SW_STATE[7] <= SW[2]; 	// PSW8
				SW_STATE[11] <= SW[1];	// PSW12
				SW_STATE[15] <= SW[0]; 	// PSW16
			end
	end

endmodule	
