module Divide_Clock(CLK, RESET, LED0);

  input CLK, RESET;
  output LED0;
	
  reg LED0 = 0;
  reg [25:0]temp_count = 0;

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) temp_count <= 0;
    else if (temp_count == 49999999) temp_count <= 0;
    else temp_count <= temp_count + 1;
  end
	
  assign enable = (temp_count == 0) ? 1 : 0;
	
  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) LED0 <= 0;
    else if (enable == 1) LED0 <= ~LED0;
  end

endmodule
