module Decimal_Counter(CLK, RESET, Q);

  input CLK, RESET;
  output [3:0]Q;

  reg [3:0]Q = 0;
  reg [25:0]temp_count = 0;

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) temp_count <= 0;
    else if (temp_count == 49999999) temp_count <= 0;
    else temp_count <= temp_count + 1;
  end
	
  assign inc = (temp_count == 0) ? 1 : 0;
	
  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) Q <= 0;
    else if (inc)
    begin
      if (Q == 9) Q = 0;
      else Q <= Q + 1;
    end
  end

endmodule
