module UpDown_Counter(CLK, RESET, TSW, Q);

  input CLK, RESET;
  input [1:0] TSW;
  output [3:0] Q;

  reg [3:0] Q = 0;
  reg [18:0] temp_count = 0;
  reg [1:0] out, buffer;

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) temp_count <= 0;
    else temp_count <= temp_count + 1;
  end

  always @(posedge CLK)
    if(temp_count==0) out <= TSW;

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) buffer <= 0;
    else buffer <= out;
  end

  assign inc = out[0] & ~buffer[0];
  assign dec = out[1] & ~buffer[1];

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) Q <= 0;
    else if (inc == 1)
    begin
      if (Q == 9) Q = 0;
      else Q <= Q + 1;
    end
    else if (dec == 1)
    begin
      if (Q == 0) Q <= 9;
      else Q <= Q - 1;
    end
  end

endmodule
