module Counter_7seg(CLK, RESET, TSW, SEG);

  input CLK, RESET;
  input [1:0] TSW;
  output [7:0] SEG;

  reg [3:0] Q = 0;
  reg [18:0] temp_count = 0;
  reg [1:0] out, buffer;
  reg [7:0] SEG;

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) temp_count <= 0;
    else temp_count <= temp_count + 1;
  end

  always @(posedge CLK)
    if(temp_count==0) out <= TSW;

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) buffer <= 0;
    else buffer <= out;
  end

  assign inc = out[0] & ~buffer[0];
  assign dec = out[1] & ~buffer[1];

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) Q <= 0;
    else if (inc == 1)
    begin
      if (Q == 9) Q = 0;
      else Q <= Q + 1;
    end
    else if (dec == 1)
    begin
      if (Q == 0) Q <= 9;
      else Q <= Q - 1;
    end
  end

  always @(Q)
  begin
    case(Q)
      4'b0000:SEG <= 8'b0001_0000; //0
      4'b0001:SEG <= 8'b0001_0001; //1
      4'b0010:SEG <= 8'b0001_0010; //2
      4'b0011:SEG <= 8'b0001_0011; //3
      4'b0100:SEG <= 8'b0001_0100; //4
      4'b0101:SEG <= 8'b0001_0101; //5
      4'b0110:SEG <= 8'b0001_0110; //6
      4'b0111:SEG <= 8'b0001_0111; //7
      4'b1000:SEG <= 8'b0001_1000; //8
      4'b1001:SEG <= 8'b0001_1001; //9
      default:SEG <= 4'b0001_1111;
    endcase
  end
  
endmodule
