module SW_Matrix(CLK, RESET, COLUMN, SW, LED);

  input CLK, RESET;
  input [3:0] SW;
  
  output [3:0] COLUMN;
  output [4:0] LED;
  
  reg [3:0] COLUMN;
  reg [4:0] LED;
  reg [1:0] count = 0;

  reg [1:0]temp_count = 0;
  
  always @(posedge CLK)
    if (temp_count == 2) temp_count <= 0;
    else temp_count <= temp_count + 1;
 
  assign Enable = (temp_count == 0) ? 1 : 0;
  
  always @(posedge CLK)
    if (Enable == 1) count <= count + 1; 
  
  always @(posedge CLK)
  begin
    if (Enable == 1)
    begin
      case(count)
        2'b00:COLUMN <= 4'b1000;  // P1 High
        2'b01:COLUMN <= 4'b0100;  // P2 High
        2'b10:COLUMN <= 4'b0010;  // P3 High
        2'b11:COLUMN <= 4'b0001;  // P4 High
      endcase
    end
  end

  always @(posedge CLK or negedge RESET)
  begin
    if (!RESET) LED <= 0;
    else if (Enable == 1)
      if(COLUMN == 4'b1000)
      begin
        case(SW)
          4'b1000:LED <= 1;    // PSW1
          4'b0100:LED <= 5;    // PSW5
          4'b0010:LED <= 9;    // PSW9
          4'b0001:LED <= 13;  // PSW13
        endcase
      end
      else if(COLUMN == 4'b0100)
      begin
        case(SW)
          4'b1000:LED <= 2;    // PSW2
          4'b0100:LED <= 6;    // PSW6
          4'b0010:LED <= 10;  // PSW10
          4'b0001:LED <= 14;  // PSW14
        endcase
      end
      else if(COLUMN == 4'b0010)
      begin
        case(SW)
          4'b1000:LED <= 3;    // PSW3
          4'b0100:LED <= 7;    // PSW7
          4'b0010:LED <= 11;  // PSW11
          4'b0001:LED <= 15;  // PSW15
        endcase
      end
      else if(COLUMN == 4'b0001)
      begin
        case(SW)
          4'b1000:LED <= 4;    // PSW4
          4'b0100:LED <= 8;    // PSW8
          4'b0010:LED <= 12;  // PSW12
          4'b0001:LED <= 16;  // PSW16
        endcase
      end
  end

endmodule
